var grid;
  function ParamFormatter(row, cell, value, columnDef, dataContext) {
    var color,data = dataContext[columnDef.field] / Math.max(dataContext['/' + columnDef.field],1) * 100;
	var color;

	if (data < 0) {
		var bkc;
		if (- data < 50) {
			return "<span class='life-bar' style='background:#ccc;width:" + (- data * 2) + "%'></span><span class='lifebar_text'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
    	} else if( -data <= 100) {
			color = "#999";
			bkc = "#ccc";
			data = - data * 2 - 100;
		} else if( -data <= 150) {
			data = - data * 2 - 200;
			color = "#000";
			bkc = "#999";
		} else if( -data <= 150) {
			data = - data * 2 - 300;
			color = "#a00";
			bkc = "#000";
		} else {
			return "<span class='lifebar_text'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
		}
		return "<span class='life-bar' style='background:" + bkc +";width:100%'></span><span class='life-bar' style='background:" + color + ";width:" + (data) + "%'></span><span class='lifebar_text'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
	}

    if (data <= 25) {
      color = "#cc4444";
    } else if (data <= 50) {
      color = "#cccc00";
    } else if (data <= 75) {
      color = "#44cc44";
    } else {
      color = "#44cccc";
    }

    return "<span class='life-bar' style='background:" + color + ";width:" + data + "%'></span><span class='lifebar_text'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
  }

  function ParamEditor(args) {
    var $from, $to, $picker, $max;
    var scope = this;
	var focusOutFlag = false;
	var ActiveCell = null;
	var TimeOutID = null;

	this.Num = function(text) {
		if (text === '' || text === void(0)) {
			return 0;
		} else {
			return parseInt(text.replace(/[０-９]/g,function(s){return String.fromCharCode(s.charCodeAt(0)-0xFEE0);}),10);
		}
	};

    this.init = function () {
      $from = $("<INPUT type='text' class='editor-life-from' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);

      $(args.container).append("/");

      $to = $("<INPUT type=text class='editor-life-to' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);

	  $picker = $("<div class='editor-life-helper'><div class='editor-life-wrapper'><div class='editor-life-buttons'><button>+1</button><button>-1</button><button>MAX</button><br /><button>+5</button><button>-5</button><br /><button>+10</button><button>-10</button></div></div></div>");
      $picker.find(".editor-life-buttons button").bind("click", function (e) {
        if ($(this).text() === 'MAX') {
			$from.val($to.val());
		} else if ($(this).text() === 'CHG') {
			$from.focus();
		} else if ($max.text() === 'MAX'){
			$from.val(parseInt($(this).text(),10) + scope.Num($from.val()));
			$from.focus();
		} else {
			$to.val(parseInt($(this).text(),10) + scope.Num($to.val()));
			$to.focus();
		}
      }).focus(function (e){focusOutFlag = true;});
	  $picker.bind("click", function (e) {
	  if(! $(e.target).is("button")){
	    args.commitChanges();
		args.cancelChanges();
		grid.resetActiveCell();
	  }
	  });
	  $picker.appendTo(document.body);
	  var pt = $from[0].getBoundingClientRect();
	  $picker.css({left:pt.x + 20,top:pt.y + pt.height + $(window).scrollTop()});
	  $max = $picker.find("button").eq(2);
	  $from.bind("focus",function(e) { focusOutFlag = true; $max.text('MAX'); });
	  $to.bind("focus",function(e) { focusOutFlag = true; $max.text('CHG'); });
	  $picker.bind('focus',function(e) {focusOutFlag = true;});
	  
      scope.focus();
	  $from.focusout(this.checkFocusout);
	  $to.focusout(this.checkFocusout);
	  
	  ActiveCell = grid.getActiveCell();
    };
	this.checkFocusout = function(e) {
		focusOutFlag = false;
		TimeOutID = window.setTimeout(scope.focusTimeOut,200);
	};
	
	this.focusTimeOut = function() {
		if (! focusOutFlag) {
			turnCell = grid.getActiveCell();
			if (turnCell === null) {
				grid.resetActiveCell();
			} else if (turnCell['row'] === ActiveCell['row'] && turnCell['cell'] === ActiveCell['cell']) {
				args.commitChanges();
				args.cancelChanges();
				grid.resetActiveCell();
			}
		}
		window.clearTimeout(TimeOutID);
		TimeOutID = null;
	}

    this.handleKeyDown = function (e) {
	  if (e.keyCode == $.ui.keyCode.TAB && $to.is(':focus')) {
		$from.focus();
		$from[0].setSelectionRange(0, $from.val().length);
		e.stopImmediatePropagation();
		return false;
	  }
      if (e.keyCode == $.ui.keyCode.LEFT || e.keyCode == $.ui.keyCode.RIGHT || e.keyCode == $.ui.keyCode.TAB) {
        e.stopImmediatePropagation();
      }
    };

    this.destroy = function () {
      $(args.container).empty();
      $picker.remove();
      $from.remove();
      $to.remove();
    };

    this.focus = function () {
      $from.focus();
    };

    this.serializeValue = function () {
      return {from: scope.Num($from.val()), to: scope.Num($to.val())};
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state.from;
      item['/' + args.column.field] = state.to;
    };

    this.loadValue = function (item) {
      $from.val(item[args.column.field]);
      $to.val(item['/' + args.column.field]);
    };

    this.isValueChanged = function () {
      return args.item[args.column.field] != scope.Num($from.val()) || args.item['/' + args.column.field] != scope.Num($to.val());
    };

    this.validate = function () {
	  if (isNaN(scope.Num($from.val())) || isNaN(scope.Num($to.val()))) {
      	return {valid: false, msg: "数字でない文字が入力されました"};
      }
      return {valid: true, msg: null};
    };

    this.init();
  }

var Status_DATA = [];

$(function () {

$("#status_container").dialog({
	modal:false,
	resize:function(event) {
		var height = $("#status_container")[0].clientHeight;
		var em=$("#status_tablearea")[0].clientHeight;
		grid.resizeCanvas();
}});

  var columns = [
    {id: "title", name: "Title", field: "title", width: 120, cssClass: "cell-title", editor: Slick.Editors.Text, sortable: true},
    {id: "hp", name: "HP", field: "hp", width: 70, formatter: ParamFormatter, editor: ParamEditor, sortable: true},
    {id: "mp", name: "MP", field: "mp", width: 70, formatter: ParamFormatter, editor: ParamEditor, sortable: true},
    {id: "毒", name: "毒", field: "毒", width: 30, formatter: Slick.Formatters.Checkmark, editor: Slick.Editors.Autocheck, sortable: true}
  ];

  var options = {
    editable: true,
    enableAddRow: false,
    enableCellNavigation: true,
    asyncEditorLoading: false,
    multiColumnSort: true
  };

    for (var i = 0; i < 500; i++) {
      var d = (Status_DATA[i] = {});

      d["title"] = "Task " + i;
      d["hp"] = Math.round(Math.random() * 100);
      d["/hp"] = d["hp"] + Math.round(Math.random() * 100);
      d["mp"] = Math.round(Math.random() * 100);
      d["/mp"] = d["mp"] + Math.round(Math.random() * 100);
    }

    grid = new Slick.Grid("#status_tablearea", Status_DATA, columns, options);

    grid.onValidationError.subscribe(function (e, args) {
      alert(args.validationResults.msg);
    });

    grid.onSort.subscribe(function (e, args) {
      var cols = args.sortCols;

      Status_DATA.sort(function (dataRow1, dataRow2) {
        for (var i = 0, l = cols.length; i < l; i++) {
          var field = cols[i].sortCol.field;
          var sign = cols[i].sortAsc ? 1 : -1;
          var value1 = dataRow1[field], value2 = dataRow2[field];
          var result = (value1 == value2 ? 0 : (value1 > value2 ? 1 : -1)) * sign;
          if (result != 0) {
            return result;
          }
        }
        return 0;
      });
      grid.invalidate();
      grid.render();
		grid.resetActiveCell();
    });
	$('#status_container').height('100px');
	grid.resizeCanvas();
  });

